// SerialClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "SerialClient.h"
#include "SerialClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CSerialClientDlg dialog




CSerialClientDlg::CSerialClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSerialClientDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSerialClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_PORTS, cbPorts);
	DDX_Control(pDX, IDC_EDIT_WRITE_TIMEOUT, edWriteTimeout);
	DDX_Control(pDX, IDC_EDIT_BAUDRATE, edBaudRate);
	DDX_Control(pDX, IDC_COMBO_RTS_CONTROL, cbRtsControl);
	DDX_Control(pDX, IDC_COMBO_PARITY, cbParity);
	DDX_Control(pDX, IDC_EDIT_XON_LIM, edXonLim);
	DDX_Control(pDX, IDC_COMBO_DTR_CONTROL, cbDtrControl);
	DDX_Control(pDX, IDC_COMBO_BYTE_SIZE, cbByteSize);
	DDX_Control(pDX, IDC_COMBO_STOP_BITS, cbStopBits);
	DDX_Control(pDX, IDC_EDIT_XOFF_LIM, edXoffLim);
	DDX_Control(pDX, IDC_EDIT_XON_CHAR, edXonChar);
	DDX_Control(pDX, IDC_EDIT_XOFF_CHAR, edXoffChar);
	DDX_Control(pDX, IDC_EDIT_ERROR_CHAR, edErrorChar);
	DDX_Control(pDX, IDC_EDIT_EOF_CHAR, edEofChar);
	DDX_Control(pDX, IDC_EDIT_EVT_CHAR, edEvtChar);
	DDX_Control(pDX, IDC_CHECK_PARITY_CHECK, cbParityCheck);
	DDX_Control(pDX, IDC_CHECK_OUTX_DSR_FLOW, cbOutxDsrFlow);
	DDX_Control(pDX, IDC_CHECK_TX_CONTINUE_ON_XOFF, cbTXContinueOnXoff);
	DDX_Control(pDX, IDC_CHECK_ERROR_CHAR_REPLACE, cbErrorCharReplace);
	DDX_Control(pDX, IDC_CHECK_NULL_STRIP, cbNullStrip);
	DDX_Control(pDX, IDC_CHECK_OUTX_CTS_FLOW, cbOutxCtsFlow);
	DDX_Control(pDX, IDC_CHECK_DSR_SENSITIVITY, cbDsrSensitivity);
	DDX_Control(pDX, IDC_CHECK_OUTX, cbOutx);
	DDX_Control(pDX, IDC_CHECK_INX, cbInx);
	DDX_Control(pDX, IDC_CHECK_ABORT_ON_ERROR, cbAbortOnError);
	DDX_Control(pDX, IDC_EDIT_READ_BUFFER_SIZE, edReadBufferSize);
	DDX_Control(pDX, IDC_EDIT_WRITE_BUFFER_SIZE, edWriteBufferSize);
	DDX_Control(pDX, IDC_EDIT_READ_INTRVAL, edReadInterval);
	DDX_Control(pDX, IDC_EDIT_READ_MULTY, edReadMultiplier);
	DDX_Control(pDX, IDC_EDIT_READ_CONSTANT, edReadConstant);
	DDX_Control(pDX, IDC_EDIT_WRITE_MULTY, edWriteMultiplier);
	DDX_Control(pDX, IDC_EDIT_WRITE_CONSTANT, edWriteConstant);
	DDX_Control(pDX, IDC_COMBO_FUNC, cbFunc);
	DDX_Control(pDX, IDC_CHECK_RX_ABORT, cbRxAbort);
	DDX_Control(pDX, IDC_CHECK_TX_ABORT, cbTxAbort);
	DDX_Control(pDX, IDC_CHECK_RX_CLEAR, cbRxClear);
	DDX_Control(pDX, IDC_CHECK_TX_CLEAR, cbTxClear);
	DDX_Control(pDX, IDC_EDIT_CHAR_CODE, edChar);
	DDX_Control(pDX, IDC_EDIT_TEXT, edText);
	DDX_Control(pDX, IDC_LIST_EVENTS, lbEvents);
	DDX_Control(pDX, IDC_COMBO_LINE_FEED, cbLineFeed);
}

BEGIN_MESSAGE_MAP(CSerialClientDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, &CSerialClientDlg::OnBnClickedButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_ENUM, &CSerialClientDlg::OnBnClickedButtonEnum)
	ON_BN_CLICKED(IDC_BUTTON_CONNECT, &CSerialClientDlg::OnBnClickedButtonConnect)
	ON_BN_CLICKED(IDC_BUTTON_DISCONNECT, &CSerialClientDlg::OnBnClickedButtonDisconnect)
	ON_BN_CLICKED(IDC_BUTTON_SET_CONFIG, &CSerialClientDlg::OnBnClickedButtonSetConfig)
	ON_BN_CLICKED(IDC_BUTTON_GET_CONFIG, &CSerialClientDlg::OnBnClickedButtonGetConfig)
	ON_BN_CLICKED(IDC_BUTTON_GET_BUFFERS, &CSerialClientDlg::OnBnClickedButtonGetBuffers)
	ON_BN_CLICKED(IDC_BUTTON_SET_BUFFERS, &CSerialClientDlg::OnBnClickedButtonSetBuffers)
	ON_BN_CLICKED(IDC_BUTTON_GET_TIMEOUTS, &CSerialClientDlg::OnBnClickedButtonGetTimeouts)
	ON_BN_CLICKED(IDC_BUTTON_SET_TIMEOUTS, &CSerialClientDlg::OnBnClickedButtonSetTimeouts)
	ON_BN_CLICKED(IDC_BUTTON_CLEAR_COMM_BREAD, &CSerialClientDlg::OnBnClickedButtonClearCommBread)
	ON_BN_CLICKED(IDC_BUTTON_SET_COMM_BREAK, &CSerialClientDlg::OnBnClickedButtonSetCommBreak)
	ON_BN_CLICKED(IDC_BUTTON_FLUSH, &CSerialClientDlg::OnBnClickedButtonFlush)
	ON_BN_CLICKED(IDC_BUTTON_EXEC_FUNC, &CSerialClientDlg::OnBnClickedButtonExecFunc)
	ON_BN_CLICKED(IDC_BUTTONPURGE, &CSerialClientDlg::OnBnClickedButtonpurge)
	ON_BN_CLICKED(IDC_BUTTON_TRANSMIT, &CSerialClientDlg::OnBnClickedButtonTransmit)
	ON_BN_CLICKED(IDC_BUTTON_SEND, &CSerialClientDlg::OnBnClickedButtonSend)
	ON_BN_CLICKED(IDC_BUTTON_SET_WRITE_TIMEOUT, &CSerialClientDlg::OnBnClickedButtonSetWriteTimeout)
END_MESSAGE_MAP()


// CSerialClientDlg message handlers

BOOL CSerialClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	cbRtsControl.AddString(_T("rtsControlDisable"));
	cbRtsControl.AddString(_T("rtsControlEnable"));
	cbRtsControl.AddString(_T("rtsControlHandshake"));
	cbRtsControl.AddString(_T("rtsControlToggle"));

	cbParity.AddString(_T("spNo"));
	cbParity.AddString(_T("spOdd"));
	cbParity.AddString(_T("spEven"));
	cbParity.AddString(_T("spMark"));
	cbParity.AddString(_T("spSpace"));

	cbDtrControl.AddString(_T("dtrControlDisable"));
	cbDtrControl.AddString(_T("dtrControlEnable"));
	cbDtrControl.AddString(_T("dtrControlHandshake"));

	cbByteSize.AddString(_T("4"));
	cbByteSize.AddString(_T("5"));
	cbByteSize.AddString(_T("6"));
	cbByteSize.AddString(_T("7"));
	cbByteSize.AddString(_T("8"));

	cbStopBits.AddString(_T("sbOne"));
	cbStopBits.AddString(_T("sbOne5"));
	cbStopBits.AddString(_T("sbTwo"));

	cbFunc.AddString(_T("escClrBreak"));
	cbFunc.AddString(_T("escClrDtr"));
	cbFunc.AddString(_T("escClrRts"));
	cbFunc.AddString(_T("escSetBreak"));
	cbFunc.AddString(_T("escSetDtr"));
	cbFunc.AddString(_T("escSetRts"));
	cbFunc.AddString(_T("escSetXoff"));
	cbFunc.AddString(_T("escSetXon"));
	cbFunc.SetCurSel(0);

	cbLineFeed.AddString(_T("None"));
	cbLineFeed.AddString(_T("CR"));
	cbLineFeed.AddString(_T("LF"));
	cbLineFeed.AddString(_T("CR & LF"));
	cbLineFeed.SetCurSel(0);

	edChar.SetWindowText(_T("0"));

	edText.SetWindowText(_T("Something to send to serial"));

	EnumComPorts();
	
	ClearConfig();
	ClearTiemouts();
	ClearBuffers();
	
	CString s;
	s.Format(_T("%d"), wclSerialClient.WriteTimeout);
	edWriteTimeout.SetWindowText(s);

	__hook(&CwclSerialClient::OnConnect, &wclSerialClient, &CSerialClientDlg::wclSerialClientConnect);
	__hook(&CwclSerialClient::OnData, &wclSerialClient, &CSerialClientDlg::wclSerialClientData);
	__hook(&CwclSerialClient::OnDisconnect, &wclSerialClient, &CSerialClientDlg::wclSerialClientDisconnect);
	__hook(&CwclSerialClient::OnError, &wclSerialClient, &CSerialClientDlg::wclSerialClientError);
	__hook(&CwclSerialClient::OnReadError, &wclSerialClient, &CSerialClientDlg::wclSerialClientReadError);
	__hook(&CwclSerialClient::OnEvents, &wclSerialClient, &CSerialClientDlg::wclSerialClientEvents);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSerialClientDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSerialClientDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CSerialClientDlg::OnDestroy()
{
	CDialog::OnDestroy();

	wclSerialClient.Disconnect();
	__unhook(&wclSerialClient);
}

void CSerialClientDlg::OnBnClickedButtonClear()
{
	lbEvents.ResetContent();
}

void CSerialClientDlg::ReadConfiguration()
{
	wclSerialConfig Config;
	int Res = wclSerialClient.GetConfig(Config);
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Read configuration error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
	else
	{
		CString s;
		s.Format(_T("%d"), Config.BaudRate);
		edBaudRate.SetWindowText(s);
		s.Format(_T("%d"), Config.XonLim);
		edXonLim.SetWindowText(s);
		s.Format(_T("%d"), Config.XoffLim);
		edXoffLim.SetWindowText(s);
		s.Format(_T("%d"), (unsigned char)Config.XonChar);
		edXonChar.SetWindowText(s);
		s.Format(_T("%d"), (unsigned char)Config.XoffChar);
		edXoffChar.SetWindowText(s);
		s.Format(_T("%d"), (unsigned char)Config.ErrorChar);
		edErrorChar.SetWindowText(s);
		s.Format(_T("%d"), (unsigned char)Config.EofChar);
		edEofChar.SetWindowText(s);
		s.Format(_T("%d"), (unsigned char)Config.EvtChar);
		edEvtChar.SetWindowText(s);
		
		cbParityCheck.SetCheck(Config.ParityCheck);
		cbOutxCtsFlow.SetCheck(Config.OutxCtsFlow);
		cbOutxDsrFlow.SetCheck(Config.OutxDsrFlow);
		cbDsrSensitivity.SetCheck(Config.DsrSensitivity);
		cbTXContinueOnXoff.SetCheck(Config.TXContinueOnXoff);
		cbOutx.SetCheck(Config.OutX);
		cbInx.SetCheck(Config.InX);
		cbErrorCharReplace.SetCheck(Config.ErrorCharReplace);
		cbNullStrip.SetCheck(Config.NullStrip);
		cbAbortOnError.SetCheck(Config.AbortOnError);
		
		cbRtsControl.SetCurSel(Config.RtsControl);
		cbDtrControl.SetCurSel(Config.DtrControl);
		cbByteSize.SetCurSel(Config.ByteSize - 4);
		cbParity.SetCurSel(Config.Parity);
		cbStopBits.SetCurSel(Config.StopBits);
	}
}

void CSerialClientDlg::ReadTiemouts()
{
	wclSerialTimeouts Times;
	int Res = wclSerialClient.GetTimeouts(Times);
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Get timeouts error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
	else
	{
		CString s;
		s.Format(_T("%d"), Times.ReadInterval);
		edReadInterval.SetWindowText(s);
		s.Format(_T("%d"), Times.ReadMultiplier);
		edReadMultiplier.SetWindowText(s);
		s.Format(_T("%d"), Times.ReadConstant);
		edReadConstant.SetWindowText(s);
		s.Format(_T("%d"), Times.WriteMultiplier);
		edWriteMultiplier.SetWindowText(s);
		s.Format(_T("%d"), Times.WriteConstant);
		edWriteConstant.SetWindowText(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonEnum()
{
	EnumComPorts();
}

void CSerialClientDlg::EnumComPorts()
{
	cbPorts.ResetContent();
	
	wclSerialDevices Ports;
	int Res = wclSerialMonitor.EnumDevices(Ports);
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error enumerating COM ports: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
	else
	{
		for (wclSerialDevices::iterator i = Ports.begin(); i != Ports.end(); i++)
			cbPorts.AddString((*i).DeviceName.c_str());
		
		if (cbPorts.GetCount() > 0)
			cbPorts.SetCurSel(0);
		else
			cbPorts.SetCurSel(-1);
	}
}

void CSerialClientDlg::OnBnClickedButtonConnect()
{
	if (cbPorts.GetCurSel() == -1)
		AfxMessageBox(_T("Select COM port"));
	else
	{
		CString s;
		cbPorts.GetWindowText(s);
		wclSerialClient.DeviceName = tstring(s);
		
		int Res = wclSerialClient.Connect();
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("Error: 0x%.8X"), Res);
			AfxMessageBox(s);
		}
	}
}

void CSerialClientDlg::OnBnClickedButtonDisconnect()
{
	int Res = wclSerialClient.Disconnect();
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x%.8X"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::ClearConfig()
{
	edBaudRate.SetWindowText(_T(""));
	edXonLim.SetWindowText(_T(""));
	edXoffLim.SetWindowText(_T(""));
	edXonChar.SetWindowText(_T(""));
	edXoffChar.SetWindowText(_T(""));
	edErrorChar.SetWindowText(_T(""));
	edEofChar.SetWindowText(_T(""));
	edEvtChar.SetWindowText(_T(""));
	
	cbParityCheck.SetCheck(FALSE);
	cbOutxCtsFlow.SetCheck(FALSE);
	cbOutxDsrFlow.SetCheck(FALSE);
	cbDsrSensitivity.SetCheck(FALSE);
	cbTXContinueOnXoff.SetCheck(FALSE);
	cbOutx.SetCheck(FALSE);
	cbInx.SetCheck(FALSE);
	cbErrorCharReplace.SetCheck(FALSE);
	cbNullStrip.SetCheck(FALSE);
	cbAbortOnError.SetCheck(FALSE);
	
	cbRtsControl.SetCurSel(-1);
	cbDtrControl.SetCurSel(-1);
	cbByteSize.SetCurSel(-1);
	cbParity.SetCurSel(-1);
	cbStopBits.SetCurSel(-1);
}

void CSerialClientDlg::OnBnClickedButtonSetConfig()
{
	wclSerialConfig Config;
	CString s;
	
	edBaudRate.GetWindowText(s);
	Config.BaudRate = _ttoi(s);
	edXonLim.GetWindowText(s);
	Config.XonLim = LOWORD(_ttoi(s));
	edXoffLim.GetWindowText(s);
	Config.XoffLim = LOWORD(_ttoi(s));
	edXonChar.GetWindowText(s);
    Config.XonChar = LOBYTE(LOWORD(_ttoi(s)));
	edXoffChar.GetWindowText(s);
    Config.XoffChar = LOBYTE(LOWORD(_ttoi(s)));
	edErrorChar.GetWindowText(s);
	Config.ErrorChar = LOBYTE(LOWORD(_ttoi(s)));
	edEofChar.GetWindowText(s);
	Config.EofChar = LOBYTE(LOWORD(_ttoi(s)));
	edEvtChar.GetWindowText(s);
    Config.EvtChar = LOBYTE(LOWORD(_ttoi(s)));
	
	Config.ParityCheck = cbParityCheck.GetCheck() != 0;
	Config.OutxCtsFlow = cbOutxCtsFlow.GetCheck() != 0;
	Config.OutxDsrFlow = cbOutxDsrFlow.GetCheck() != 0;
	Config.DsrSensitivity = cbDsrSensitivity.GetCheck() != 0;
	Config.TXContinueOnXoff = cbTXContinueOnXoff.GetCheck() != 0;
	Config.OutX = cbOutx.GetCheck() != 0;
	Config.InX = cbInx.GetCheck() != 0;
	Config.ErrorCharReplace = cbErrorCharReplace.GetCheck() != 0;
	Config.NullStrip = cbNullStrip.GetCheck() != 0;
	Config.AbortOnError = cbAbortOnError.GetCheck() != 0;
	
	Config.RtsControl = (wclSerialRtsControl)cbRtsControl.GetCurSel();
	Config.DtrControl = (wclSerialDtrControl)cbDtrControl.GetCurSel();
	Config.ByteSize = LOBYTE(LOWORD(cbByteSize.GetCurSel() + 4));
	Config.Parity = (wclSerialParity)cbParity.GetCurSel();
	Config.StopBits = (wclSerialStopBits)cbStopBits.GetCurSel();
	
	int Res = wclSerialClient.SetConfig(Config);
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Error: 0x%.8X"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonGetConfig()
{
	ReadConfiguration();
}

void CSerialClientDlg::ClearBuffers()
{
	edReadBufferSize.SetWindowText(_T(""));
	edWriteBufferSize.SetWindowText(_T(""));
}

void CSerialClientDlg::ClearTiemouts()
{
	edReadInterval.SetWindowText(_T(""));
	edReadMultiplier.SetWindowText(_T(""));
	edReadConstant.SetWindowText(_T(""));
	edWriteMultiplier.SetWindowText(_T(""));
	edWriteConstant.SetWindowText(_T(""));
}

void CSerialClientDlg::ReadBuffers()
{
	CString s;
	unsigned long Size;
	int Res = wclSerialClient.GetReadBufferSize(Size);
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Get read buffer size error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
	else
	{
		s.Format(_T("%d"), Size);
		edReadBufferSize.SetWindowText(s);
	}
	
	Res = wclSerialClient.GetWriteBufferSize(Size);
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Get write buffer size error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
	else
	{
		s.Format(_T("%d"), Size);
		edWriteBufferSize.SetWindowText(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonGetBuffers()
{
	ReadBuffers();
}

void CSerialClientDlg::OnBnClickedButtonSetBuffers()
{
	CString s;
	edReadBufferSize.GetWindowText(s);
	int Res = wclSerialClient.SetReadBufferSize(_ttoi(s));
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Set read buffer size error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}

	edWriteBufferSize.GetWindowText(s);
	Res = wclSerialClient.SetWriteBufferSize(_ttoi(s));
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Set write buffer size error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonGetTimeouts()
{
	ReadTiemouts();
}

void CSerialClientDlg::OnBnClickedButtonSetTimeouts()
{
	CString s;
	wclSerialTimeouts Times;
	edReadInterval.GetWindowText(s);
	Times.ReadInterval = _ttoi(s);
	edReadMultiplier.GetWindowText(s);
	Times.ReadMultiplier = _ttoi(s);
	edReadConstant.GetWindowText(s);
	Times.ReadConstant = _ttoi(s);
	edWriteMultiplier.GetWindowText(s);
	Times.WriteMultiplier = _ttoi(s);
	edWriteConstant.GetWindowText(s);
	Times.WriteConstant = _ttoi(s);
	
	int Res = wclSerialClient.SetTimeouts(Times);
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Set timeouts error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonClearCommBread()
{
	int Res = wclSerialClient.ClearCommBreak();
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x%.8X"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonSetCommBreak()
{
	int Res = wclSerialClient.SetCommBreak();
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonFlush()
{
	int Res = wclSerialClient.FlushBuffers();
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonExecFunc()
{
	int Res = wclSerialClient.EscapeCommFunction((wclSerialEscapeFunction)cbFunc.GetCurSel());
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonpurge()
{
	wclSerialPurgeFlags Flags;
	if (cbRxAbort.GetCheck())
		Flags.insert(purgeRxAbort);
	if (cbRxClear.GetCheck())
		Flags.insert(purgeRxClear);
	if (cbTxAbort.GetCheck())
		Flags.insert(purgeTxAbort);
	if (cbTxClear.GetCheck())
		Flags.insert(purgeTxClear);
	
	int Res = wclSerialClient.PurgeComm(Flags);
	if (Res != WCL_E_SUCCESS)
	{
		CString s;
		s.Format(_T("Error: 0x"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonTransmit()
{
	CString s;
	edChar.GetWindowText(s);
	int Res = wclSerialClient.TransmitCommChar(LOBYTE(LOWORD(_ttoi(s))));
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Error: 0x"), Res);
		AfxMessageBox(s);
	}
}

void CSerialClientDlg::OnBnClickedButtonSend()
{
	CString s;
	edText.GetWindowText(s);
	CStringA a(s);
	switch (cbLineFeed.GetCurSel())
	{
		case 1:
			a += '\r';
			break;
		case 2:
			a += '\n';
			break;
		case 3:
			a += "\r\n";
			break;
	}
	unsigned long Written;
	int Res = wclSerialClient.Write(a.GetBuffer(), a.GetLength(), Written);
	s.Format(_T("Sent: %d bytes from %d"), Written, a.GetLength());
	lbEvents.AddString(s);
	if (Res != WCL_E_SUCCESS)
	{
		s.Format(_T("Write error: 0x%.8X"), Res);
		lbEvents.AddString(s);
	}
}

void CSerialClientDlg::wclSerialClientConnect(void* Sender, const int Error)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	if (Error == WCL_E_SUCCESS)
	{
		s = _T("Connected to Serial Device: ");
		s += CString(wclSerialClient.DeviceName.c_str());
		lbEvents.AddString(s);
		
		ReadConfiguration();
		ReadTiemouts();
		ReadBuffers();
	}
	else
	{
		s.Format(_T("Connect error: 0x%.8X"), Error);
		lbEvents.AddString(s);
	}
}

void CSerialClientDlg::wclSerialClientData(void* Sender, const void* const Data, 
	const unsigned long Size)
{
	UNREFERENCED_PARAMETER(Sender);

	if (Size > 0)
	{
		CStringA a((PCHAR)Data, Size);
		CString s(a);
		lbEvents.AddString(s);
	}
	else
		lbEvents.AddString(_T("Empty data received"));
}

void CSerialClientDlg::wclSerialClientDisconnect(void* Sender, const int Reason)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Disconnected: 0x%.8X"), Reason);
	lbEvents.AddString(s);
	
	ClearConfig();
	ClearTiemouts();
	ClearBuffers();
}

void CSerialClientDlg::wclSerialClientError(void* Sender, const wclSerialErrors& Errors,
	const wclSerialCommunicationStates& States)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	if (Errors.find(erBreak) != Errors.end())
		s += _T("erBreak ");
	if (Errors.find(erFrame) != Errors.end())
		s += _T("erFrame ");
	if (Errors.find(erOverrun) != Errors.end())
		s += _T("erOverrun ");
	if (Errors.find(erRxOver) != Errors.end())
		s += _T("erRxOver ");
	if (Errors.find(erRxParity) != Errors.end())
		s += _T("erRxParity ");
	lbEvents.AddString(_T("Error: ") + s);
	
	s = _T("");
	if (States.find(csCtsHold) != States.end())
		s += _T("csCtsHold ");
	if (States.find(csDsrHold) != States.end())
		s += _T("csDsrHold ");
	if (States.find(csRlsdHold) != States.end())
		s += _T("csRlsdHold ");
	if (States.find(csXoffHold) != States.end())
		s += _T("csXoffHold ");
	if (States.find(csXoffSent) != States.end())
		s += _T("csXoffSent ");
	if (States.find(csEof) != States.end())
		s += _T("csEof ");
	if (States.find(csTxim) != States.end())
		s += _T("csTxim ");
	lbEvents.AddString(_T("States: ") + s);
}

void CSerialClientDlg::wclSerialClientReadError(void* Sender, const int Error)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	s.Format(_T("Read error: 0x%.8X"), Error);
	lbEvents.AddString(s);
}

void CSerialClientDlg::wclSerialClientEvents(void* Sender, const wclSerialEvents& Events)
{
	UNREFERENCED_PARAMETER(Sender);

	CString s;
	if (Events.find(evBreak) != Events.end())
		s += _T("evBreak ");
	if (Events.find(evCts) != Events.end())
		s += _T("evCts ");
	if (Events.find(evDsr) != Events.end())
		s += _T("evDsr ");
	if (Events.find(evRing) != Events.end())
		s += _T("evRing ");
	if (Events.find(evRlsd) != Events.end())
		s += _T("evRlsd ");
	if (Events.find(evChar) != Events.end())
		s += _T("evChar ");
	lbEvents.AddString(_T("Event: ") + s);
	
	if (!Events.empty())
	{
		wclModemStatuses Status;
		int Res = wclSerialClient.GetModemStatus(Status);
		if (Res != WCL_E_SUCCESS)
		{
			s.Format(_T("GetModemStatus error: 0x%.8X"), Res);
			lbEvents.AddString(s);
		}
		else
		{
			s = _T("");
			if (Status.find(msCtsOn) != Status.end())
				s += _T("msCtsOn ");
			if (Status.find(msDsrOn) != Status.end())
				s += _T("msDsrOn ");
			if (Status.find(msRingOn) != Status.end())
				s += _T("msRingOn ");
			if (Status.find(msDsrOn) != Status.end())
				s += _T("msDsrOn ");
			if (Status.find(msRlsdOn) != Status.end())
				s += _T("msRlsdOn ");
			if (s != _T(""))
				lbEvents.AddString(_T("Modem status: ") + s);
		}
	}
}

void CSerialClientDlg::OnBnClickedButtonSetWriteTimeout()
{
	CString s;
	edWriteTimeout.GetWindowText(s);
	wclSerialClient.WriteTimeout = _ttoi(s);
}
