// SerialClientDlg.h : header file
//

#pragma once
#include "afxwin.h"

#include "..\..\..\..\Source\Serial\wclSerialClients.h"

using namespace wclCommon;
using namespace wclSerial;


// CSerialClientDlg dialog
class CSerialClientDlg : public CDialog
{
// Construction
public:
	CSerialClientDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	enum { IDD = IDD_SERIALCLIENT_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support


// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
private:
	CComboBox cbPorts;
	CEdit edWriteTimeout;
	CEdit edBaudRate;
	CComboBox cbRtsControl;
	CComboBox cbParity;
	CEdit edXonLim;
	CComboBox cbDtrControl;
	CComboBox cbByteSize;
	CComboBox cbStopBits;
	CEdit edXoffLim;
	CEdit edXonChar;
	CEdit edXoffChar;
	CEdit edErrorChar;
	CEdit edEofChar;
	CEdit edEvtChar;
	CButton cbParityCheck;
	CButton cbOutxDsrFlow;
	CButton cbTXContinueOnXoff;
	CButton cbErrorCharReplace;
	CButton cbNullStrip;
	CButton cbOutxCtsFlow;
	CButton cbDsrSensitivity;
	CButton cbOutx;
	CButton cbInx;
	CButton cbAbortOnError;
	CEdit edReadBufferSize;
	CEdit edWriteBufferSize;
	CEdit edReadInterval;
	CEdit edReadMultiplier;
	CEdit edReadConstant;
	CEdit edWriteMultiplier;
	CEdit edWriteConstant;
	CComboBox cbFunc;
	CButton cbRxAbort;
	CButton cbTxAbort;
	CButton cbRxClear;
	CButton cbTxClear;
	CEdit edChar;
	CEdit edText;
	CListBox lbEvents;

	CwclSerialMonitor wclSerialMonitor;
	CwclSerialClient wclSerialClient;

	void ReadConfiguration();
	void ReadTiemouts();
	void EnumComPorts();
	void ClearConfig();
	void ClearBuffers();
	void ClearTiemouts();
	void ReadBuffers();

	void wclSerialClientConnect(void* Sender, const int Error);
	void wclSerialClientData(void* Sender, const void* const Data, 
		const unsigned long Size);
	void wclSerialClientDisconnect(void* Sender, const int Reason);
	void wclSerialClientError(void* Sender, const wclSerialErrors& Errors,
		const wclSerialCommunicationStates& States);
	void wclSerialClientReadError(void* Sender, const int Error);
	void wclSerialClientEvents(void* Sender, const wclSerialEvents& Events);

public:
	afx_msg void OnDestroy();
	afx_msg void OnBnClickedButtonClear();
	afx_msg void OnBnClickedButtonEnum();
	afx_msg void OnBnClickedButtonConnect();
	afx_msg void OnBnClickedButtonDisconnect();
	afx_msg void OnBnClickedButtonSetConfig();
	afx_msg void OnBnClickedButtonGetConfig();
	afx_msg void OnBnClickedButtonGetBuffers();
	afx_msg void OnBnClickedButtonSetBuffers();
	afx_msg void OnBnClickedButtonGetTimeouts();
	afx_msg void OnBnClickedButtonSetTimeouts();
	afx_msg void OnBnClickedButtonClearCommBread();
	afx_msg void OnBnClickedButtonSetCommBreak();
	afx_msg void OnBnClickedButtonFlush();
	afx_msg void OnBnClickedButtonExecFunc();
	afx_msg void OnBnClickedButtonpurge();
	afx_msg void OnBnClickedButtonTransmit();
	afx_msg void OnBnClickedButtonSend();
	afx_msg void OnBnClickedButtonSetWriteTimeout();
private:
	CComboBox cbLineFeed;
};
